










































































































































































































































































































from random import randint, sample, uniform, choices
import sys
import math
import string

def gimme(a_man_after_midnight=1):
    if a_man_after_midnight == 1:
        return sample(range(-100, 100), 100)
    elif a_man_after_midnight == 2:
        return zip(sample(range(-100, 100), 100), sample(range(-100, 100), 10))
    raise ValueError()

class Test:
    def __init__(self, fn):
        self.fn = fn
    
    def die_antwort(self):
        yield lambda: self.fn() == 42

    def add(self):
        for x, y in gimme(2):
            yield lambda: self.fn(x, y) == sum([x, y])
    
    def ist_gerade(self):
        for i in gimme():
            yield lambda: self.fn(i) == (i % 2 == 0)

    def ist_ungerade(self):
        for i in gimme():
            yield lambda: self.fn(i) == (i % 2 == 1)
    
    def ist_vielfaches(self):
        yield lambda: self.fn(12, 4) == True
        yield lambda: self.fn(100, 25) == True
        yield lambda: self.fn(15, 5) == True
        yield lambda: self.fn(200, 1) == True
        yield lambda: self.fn(10, 5) == True
        for x, y in gimme(2):
            x = abs(x)
            y = abs(y)
            if y == 0:
                continue
            yield lambda: self.fn(x, y) == (x / y == x // y)

    def celcius(self):
        for x in gimme():
            yield lambda: (self.fn(x) == ((x - 32) / 1.8)) or (self.fn(x) == (x - 32) * 5/9)
    
    def distanz(self):
        for x, y in gimme(2):
            yield lambda: self.fn(x, y) == math.sqrt(x ** 2 + y ** 2)
    
    def kreisumfang(self):
        for x in gimme():
            x = abs(x)
            yield lambda: self.fn(x) == 2 * math.pi * x
    
    def im_kreis(self):
        a = [uniform(-1.5, 1.5) for c in range(10)]    
        b = [uniform(-1.5, 1.5) for c in range(10)]
        
        for x, y in zip(a, b):
            if math.sqrt(x ** 2 + y ** 2) == 1:
                continue
            yield lambda: self.fn(x, y) == (math.sqrt(x ** 2 + y ** 2) <= 1)
    
    def buchstabe_a(self):
        for x in range(10):
            s = ''.join(choices(string.ascii_uppercase + string.ascii_lowercase, k=100))
            c = s.count("a") + s.count("A")
            yield lambda: self.fn(s) == c
    
    def kuchen_backen(self):
        yield lambda: self.fn("eier") == True
        yield lambda: self.fn("tomate") == False
        yield lambda: self.fn("schokolade") == False
        yield lambda: self.fn("schmalz") == True
        yield lambda: self.fn("python") == False
        yield lambda: self.fn("zucker") == True
        yield lambda: self.fn("milch") == True
        yield lambda: self.fn("mehl") == True
        yield lambda: self.fn("pizza") == False
        yield lambda: self.fn("kaese") == False
        yield lambda: self.fn("safran") == True
        
    def snake_case(self):
        yield lambda: self.fn("halloWelt") == "hallo_welt"
        yield lambda: self.fn("kuchenBacken") == "kuchen_backen"
        yield lambda: self.fn("grundlagenIt") == "grundlagen_it"
        yield lambda: self.fn("werASagt") == "wer_a_sagt"
        yield lambda: self.fn("aBcDe") == "a_bc_de"

    def quersumme(self):
        for x in gimme():
            s = str(x + 10000)
            qs = sum([int(y) for y in s])
            yield lambda: self.fn(x + 10000) == qs
                
    def laenge(self):
        for x in gimme():
            if x == 0:
                continue
            
            l = [x] * abs(x)
            yield lambda: self.fn(l) == len(l)
    
    def maximum(self):
        for z in range(10):
            x = list(gimme())
            yield lambda: self.fn(x) == max(x)
    
    def mittelwert(self):
        for z in range(10):
            x = list(gimme())
            yield lambda: self.fn(x) == sum(x) / len(x)
            
    def bubblesort(self):
        for z in range(10):
            x = list(gimme())
            yield lambda: self.fn(x) == sorted(x)
    
    def distanz2(self):
        for x, y in gimme(2):
            x2 = randint(-100, 100)
            y2 = randint(-100, 100)
            yield lambda: self.fn([x, y], [x2, y2]) == math.sqrt((x - x2) ** 2 + (y - y2) ** 2)

    def alter(self):
        for x in range(10):
            a = randint(2000, 2100)
            b = randint(1950, 1990)
            dct = {"name": "Hans", "ort": "Mittweida", "geburtsjahr": b}
            yield lambda: self.fn(dct, a) == a - b

    def alter2(self):
        for x in range(10):
            a = randint(2000, 2100)
            b = randint(1950, 1990)
            dct = {"name": "Hans", "ort": "Mittweida", "geburtsjahr": b}
            self.fn(dct, a)
            if "alter" not in dct:
                yield lambda: False
            else:
                yield lambda: dct["alter"] == a - b

    def aeltester(self):
        num = sample(range(1900, 2100), 100)
        alt = min(num)
        a = list(map(lambda b: {"name": "Hans", "ort": "Mittweida", "geburtsjahr": b}, num))
        yield lambda: self.fn(a).get("geburtsjahr", 0) == alt
        num = sample(range(1900, 2100), 100)
        alt = min(num)
        a = list(map(lambda b: {"name": "Hans", "ort": "Mittweida", "geburtsjahr": b}, num))
        yield lambda: self.fn(a).get("geburtsjahr", 0) == alt

    def wohnort(self):
        orte = ["Mittweida", "Dresden", "Chemnitz", "Berlin"]
        ort = [orte[randint(0, 3)] for x in range(10)]
        d = {}
        if ort.count("Mittweida") > 0:
            d["Mittweida"] = ort.count("Mittweida")
        if ort.count("Dresden") > 0:
            d["Dresden"] = ort.count("Dresden")
        if ort.count("Chemnitz") > 0:
            d["Chemnitz"] = ort.count("Chemnitz")
        if ort.count("Berlin") > 0:
            d["Berlin"] = ort.count("Berlin")
        
        dd = list(map(lambda x: {"name": "Hans", "ort": x, "geburtsjahr": randint(1950, 2010)}, ort))
        yield lambda: self.fn(dd) == d

    
def test(fn):
    t = Test(fn)
    
    testfn = getattr(t, fn.__name__, None)
    if testfn is None:
        raise ValueError(f"Unbekannter Funktionsname {fn.__name__}")    
    for test in testfn():
        richtig = None
        try:
            res = test()
            assert test(), "Leider falsch :("
        except AssertionError as e:
            richtig = e
        
        
        assert not richtig, str(richtig)
            
        
    print("Die Lösung ist korrekt :)")
